<?xml version="1.0" encoding="UTF-8"?>
<cfsSimulation xmlns="http://www.cfs++.org/simulation">
  <documentation>
    <title>Test example for temperature tracking and interfaces between solid and void.</title>
     <authors>
      <author></author>
     </authors>
     <date>2016-04-18</date>
     <keywords>
      <keyword>SIMP</keyword>
     </keywords>
     <references>
      none
     </references>
     <isVerified> yes </isVerified>
     <description> none
     </description>
  </documentation>
    
    
  <fileFormats>
    <output>
      <hdf5/>
    </output>
    <materialData file="mat.xml"/>
  </fileFormats>
    
  <domain geometryType="plane">
    <regionList>
      <region name="mech" material="Iron"/>
    </regionList>
    <nodeList>
      <nodes name="source">
        <allNodesInRegion regName="mech"/>
      </nodes>
    </nodeList>
  </domain>
    
  <sequenceStep>
    <analysis>
      <static/>
    </analysis>
    <pdeList>
      <heatConduction>
        <regionList>
          <region name="mech"/>
        </regionList>
                
        <bcsAndLoads>
          <temperature name="north" value="0"/>
          <temperature name="south" value="0"/>
          <designDependentHeatSource name="source" value="999"/>
        </bcsAndLoads>
                
        <storeResults>
          <nodeResult type="heatTemperature">
            <allRegions/>
          </nodeResult>
          <elemResult type="mechPseudoDensity">
            <allRegions/>
          </elemResult>
          <elemResult type="physicalPseudoDensity">
            <allRegions/>
          </elemResult>
          <nodeResult type="heatRhsLoad">
            <allRegions/>
          </nodeResult>
        </storeResults>
      </heatConduction>
    </pdeList>
        
  </sequenceStep>
  
 <optimization>
   <costFunction type="heatEnergy" task="minimize"> 
     <stopping queue="10000" value="0.00001" type="designChange"/>
   </costFunction>
   <constraint type="volume" bound="upperBound" value="0.8"/>
   <constraint type="tempTrackingAtInterface" bound="upperBound" parameter="0.4" value="1e-2"/>
   
   <optimizer type="scpip"  maxIterations="4">
     <snopt>
       <option name="major_optimality_tolerance" type="real" value="1e-6"/>
       <option name="verify_level" type="integer" value="3"/>
     </snopt>
    </optimizer>
   
   <ersatzMaterial region="mech" material="heat" method="simp">
<!--     <filters> -->
<!--       <filter neighborhood="maxEdge" value="1.7" type="density" /> -->
<!--     </filters> -->

    <design name="density" initial="0.8"  physical_lower="1e-4" upper="1.0" region="mech"/>
    <transferFunction type="simp" application="heat" param="1.0" />
    <export write="iteration" save="last"/>
   </ersatzMaterial>
 </optimization>  


</cfsSimulation>
